]> git.street.me.uk Git - andy/dehydrated.git/blob - letsencrypt.sh
64f10f6fce0ae9b529b9c4818632bc97a58277ec
[andy/dehydrated.git] / letsencrypt.sh
1 #!/usr/bin/env bash
2 set -e
3 set -u
4 set -o pipefail
5 umask 077 # paranoid umask, we're creating private keys
6
7 # Get the directory in which this script is stored
8 SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
9 BASEDIR="${SCRIPTDIR}"
10
11 check_dependencies() {
12   curl -V > /dev/null 2>&1 || _exiterr "This script requires curl."
13   openssl version > /dev/null 2>&1 || _exiterr "This script requres an openssl binary."
14   sed "" < /dev/null > /dev/null 2>&1 || _exiterr "This script requres sed."
15   grep -V > /dev/null 2>&1 || _exiterr "This script requres grep."
16 }
17
18 # Setup default config values, search for and load configuration files
19 load_config() {
20   # Default values
21   CA="https://acme-v01.api.letsencrypt.org/directory"
22   LICENSE="https://letsencrypt.org/documents/LE-SA-v1.0.1-July-27-2015.pdf"
23   HOOK=
24   RENEW_DAYS="14"
25   PRIVATE_KEY="${BASEDIR}/private_key.pem"
26   KEYSIZE="4096"
27   WELLKNOWN="${BASEDIR}/.acme-challenges"
28   PRIVATE_KEY_RENEW="no"
29   OPENSSL_CNF="$(openssl version -d | cut -d'"' -f2)/openssl.cnf"
30   CONTACT_EMAIL=
31   LOCKFILE="${BASEDIR}/lock"
32
33   # Check for config in various locations
34   if [[ -z "${CONFIG:-}" ]]; then
35     for check_config in "/etc/letsencrypt.sh" "/usr/local/etc/letsencrypt.sh" "${PWD}" "${SCRIPTDIR}"; do
36       if [[ -e "${check_config}/config.sh" ]]; then
37         BASEDIR="${check_config}"
38         CONFIG="${check_config}/config.sh"
39         break
40       fi
41     done
42   fi
43
44   if [[ -z "${CONFIG:-}" ]]; then
45     echo "#" >&2
46     echo "# !! WARNING !! No config file found, using default config!" >&2
47     echo "#" >&2
48   elif [[ -e "${CONFIG}" ]]; then
49     echo "# INFO: Using config file ${CONFIG}"
50     BASEDIR="$(dirname "${CONFIG}")"
51     # shellcheck disable=SC1090
52     . "${CONFIG}"
53   else
54     echo "Specified config file doesn't exist." >&2
55     exit 1
56   fi
57
58   # Remove slash from end of BASEDIR. Mostly for cleaner outputs, doesn't change functionality.
59   BASEDIR="${BASEDIR%%/}"
60
61   # Check BASEDIR and set default variables
62   if [[ ! -d "${BASEDIR}" ]]; then
63    echo "BASEDIR does not exist: ${BASEDIR}" >&2
64    exit 1
65   fi
66 }
67
68 # Initialize system
69 init_system() {
70   load_config
71
72   # Lockfile handling (prevents concurrent access)
73   ( set -C; date > "${LOCKFILE}" ) 2>/dev/null || _exiterr "Lock file '${LOCKFILE}' present, aborting."
74   remove_lock() { rm -f "${LOCKFILE}"; }
75   trap 'remove_lock' EXIT
76
77   # Get CA URLs
78   CA_DIRECTORY="$(http_request get "${CA}")"
79   CA_NEW_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-cert)" &&
80   CA_NEW_AUTHZ="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-authz)" &&
81   CA_NEW_REG="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-reg)" &&
82   # shellcheck disable=SC2015
83   CA_REVOKE_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value revoke-cert)" ||
84   _exiterr "Problem retrieving ACME/CA-URLs, check if your configured CA points to the directory entrypoint."
85
86   # Export some environment variables to be used in hook script
87   export WELLKNOWN BASEDIR CONFIG
88
89   # Checking for private key ...
90   register_new_key="no"
91   if [[ -n "${PARAM_PRIVATE_KEY:-}" ]]; then
92     # a private key was specified from the command line so use it for this run
93     echo "Using private key ${PARAM_PRIVATE_KEY} instead of account key"
94     PRIVATE_KEY="${PARAM_PRIVATE_KEY}"
95   else
96     # Check if private account key exists, if it doesn't exist yet generate a new one (rsa key)
97     if [[ ! -e "${PRIVATE_KEY}" ]]; then
98       echo "+ Generating account key..."
99       _openssl genrsa -out "${PRIVATE_KEY}" "${KEYSIZE}"
100       register_new_key="yes"
101     fi
102   fi
103   openssl rsa -in "${PRIVATE_KEY}" -check 2>/dev/null > /dev/null || _exiterr "Private key is not valid, can not continue."
104
105   # Get public components from private key and calculate thumbprint
106   pubExponent64="$(openssl rsa -in "${PRIVATE_KEY}" -noout -text | grep publicExponent | grep -oE "0x[a-f0-9]+" | cut -d'x' -f2 | hex2bin | urlbase64)"
107   pubMod64="$(openssl rsa -in "${PRIVATE_KEY}" -noout -modulus | cut -d'=' -f2 | hex2bin | urlbase64)"
108
109   thumbprint="$(printf '{"e":"%s","kty":"RSA","n":"%s"}' "${pubExponent64}" "${pubMod64}" | openssl sha -sha256 -binary | urlbase64)"
110
111   # If we generated a new private key in the step above we have to register it with the acme-server
112   if [[ "${register_new_key}" = "yes" ]]; then
113     echo "+ Registering account key with letsencrypt..."
114     [[ ! -z "${CA_NEW_REG}" ]] || _exiterr "Certificate authority doesn't allow registrations."
115     # If an email for the contact has been provided then adding it to the registration request
116     if [[ -n "${CONTACT_EMAIL}" ]]; then
117       signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "contact":["mailto:'"${CONTACT_EMAIL}"'"], "agreement": "'"$LICENSE"'"}' > /dev/null
118     else
119       signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "agreement": "'"$LICENSE"'"}' > /dev/null
120     fi
121   fi
122
123   [[ -d "${WELLKNOWN}" ]] || _exiterr "WELLKNOWN directory doesn't exist, please create ${WELLKNOWN} and set appropriate permissions."
124 }
125
126 # Print error message and exit with error
127 _exiterr() {
128   echo "ERROR: ${1}" >&2
129   exit 1
130 }
131
132 anti_newline() {
133   tr -d '\n\r'
134 }
135
136 urlbase64() {
137   # urlbase64: base64 encoded string with '+' replaced with '-' and '/' replaced with '_'
138   openssl base64 -e | anti_newline | sed 's/=*$//g' | tr '+/' '-_'
139 }
140
141 # Convert hex string to binary data
142 hex2bin() {
143   # Remove spaces, add leading zero, escape as hex string and parse with printf
144   printf -- "$(cat | sed -E -e 's/[[:space:]]//g' -e 's/^(.(.{2})*)$/0\1/' -e 's/(.{2})/\\x\1/g')"
145 }
146
147 get_json_string_value() {
148   grep -Eo '"'"${1}"'":[[:space:]]*"[^"]*"' | cut -d'"' -f4
149 }
150
151 get_json_array() {
152   grep -Eo '"'"${1}"'":[^\[]*\[[^]]*]'
153 }
154
155 http_request() {
156   tempcont="$(mktemp)"
157
158   if [[ "${1}" = "head" ]]; then
159     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}" -I)"
160   elif [[ "${1}" = "get" ]]; then
161     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}")"
162   elif [[ "${1}" = "post" ]]; then
163     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}" -d "${3}")"
164   fi
165
166   if [[ ! "${statuscode:0:1}" = "2" ]]; then
167     echo "  + ERROR: An error occurred while sending ${1}-request to ${2} (Status ${statuscode})" >&2
168     echo >&2
169     echo "Details:" >&2
170     cat "${tempcont}" >&2
171     rm -f "${tempcont}"
172
173     # Wait for hook script to clean the challenge if used
174     if [[ -n "${HOOK}" ]] && [[ -n "${challenge_token:+set}"  ]]; then
175       ${HOOK} "clean_challenge" '' "${challenge_token}" "${keyauth}"
176     fi
177
178     # remove temporary domains.txt file if used
179     if [[ -n "${PARAM_DOMAIN:-}" ]]; then
180       rm "${DOMAINS_TXT}"
181     fi
182
183     exit 1
184   fi
185
186   cat "${tempcont}"
187   rm -f "${tempcont}"
188 }
189
190 # OpenSSL writes to stderr/stdout even when there are no errors. So just
191 # display the output if the exit code was != 0 to simplify debugging.
192 _openssl() {
193   set +e
194   out="$(openssl "${@}" 2>&1)"
195   res=$?
196   set -e
197   if [[ $res -ne 0 ]]; then
198     echo "  + ERROR: failed to run $* (Exitcode: $res)" >&2
199     echo >&2
200     echo "Details:" >&2
201     echo "$out" >&2
202     exit $res
203   fi
204 }
205
206 signed_request() {
207   # Encode payload as urlbase64
208   payload64="$(printf '%s' "${2}" | urlbase64)"
209
210   # Retrieve nonce from acme-server
211   nonce="$(http_request head "${CA}" | grep Replay-Nonce: | awk -F ': ' '{print $2}' | anti_newline)"
212
213   # Build header with just our public key and algorithm information
214   header='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}}'
215
216   # Build another header which also contains the previously received nonce and encode it as urlbase64
217   protected='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}, "nonce": "'"${nonce}"'"}'
218   protected64="$(printf '%s' "${protected}" | urlbase64)"
219
220   # Sign header with nonce and our payload with our private key and encode signature as urlbase64
221   signed64="$(printf '%s' "${protected64}.${payload64}" | openssl dgst -sha256 -sign "${PRIVATE_KEY}" | urlbase64)"
222
223   # Send header + extended header + payload + signature to the acme-server
224   data='{"header": '"${header}"', "protected": "'"${protected64}"'", "payload": "'"${payload64}"'", "signature": "'"${signed64}"'"}'
225
226   http_request post "${1}" "${data}"
227 }
228
229 sign_domain() {
230   domain="${1}"
231   altnames="${*}"
232
233   echo " + Signing domains..."
234   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
235     echo " + ERROR: Certificate authority doesn't allow certificate signing" >&2
236     exit 1
237   fi
238   timestamp="$(date +%s)"
239
240   # If there is no existing certificate directory => make it
241   if [[ ! -e "${BASEDIR}/certs/${domain}" ]]; then
242     echo " + make directory ${BASEDIR}/certs/${domain} ..."
243     mkdir -p "${BASEDIR}/certs/${domain}"
244   fi
245
246   privkey="privkey.pem"
247   # generate a new private key if we need or want one
248   if [[ ! -f "${BASEDIR}/certs/${domain}/privkey.pem" ]] || [[ "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
249     echo " + Generating private key..."
250     privkey="privkey-${timestamp}.pem"
251     _openssl genrsa -out "${BASEDIR}/certs/${domain}/privkey-${timestamp}.pem" "${KEYSIZE}"
252   fi
253
254   # Generate signing request config and the actual signing request
255   SAN=""
256   for altname in $altnames; do
257     SAN+="DNS:${altname}, "
258   done
259   SAN="${SAN%%, }"
260   echo " + Generating signing request..."
261   local tmp_openssl_cnf
262   tmp_openssl_cnf="$(mktemp)"
263   cat "${OPENSSL_CNF}" > "${tmp_openssl_cnf}"
264   printf "[SAN]\nsubjectAltName=%s" "${SAN}" >> "${tmp_openssl_cnf}"
265   openssl req -new -sha256 -key "${BASEDIR}/certs/${domain}/${privkey}" -out "${BASEDIR}/certs/${domain}/cert-${timestamp}.csr" -subj "/CN=${domain}/" -reqexts SAN -config "${tmp_openssl_cnf}"
266   rm -f "${tmp_openssl_cnf}"
267
268   # Request and respond to challenges
269   for altname in $altnames; do
270     # Ask the acme-server for new challenge token and extract them from the resulting json block
271     echo " + Requesting challenge for ${altname}..."
272     response="$(signed_request "${CA_NEW_AUTHZ}" '{"resource": "new-authz", "identifier": {"type": "dns", "value": "'"${altname}"'"}}')"
273
274     challenges="$(printf '%s\n' "${response}" | get_json_array challenges)"
275     repl=$'\n''{' # fix syntax highlighting in Vim
276     challenge="$(printf "%s" "${challenges//\{/${repl}}" | grep 'http-01')"
277     challenge_token="$(printf '%s' "${challenge}" | get_json_string_value token | sed 's/[^A-Za-z0-9_\-]/_/g')"
278     challenge_uri="$(printf '%s' "${challenge}" | get_json_string_value uri)"
279
280     if [[ -z "${challenge_token}" ]] || [[ -z "${challenge_uri}" ]]; then
281       echo "  + Error: Can't retrieve challenges (${response})" >&2
282       exit 1
283     fi
284
285     # Challenge response consists of the challenge token and the thumbprint of our public certificate
286     keyauth="${challenge_token}.${thumbprint}"
287
288     # Store challenge response in well-known location and make world-readable (so that a webserver can access it)
289     printf '%s' "${keyauth}" > "${WELLKNOWN}/${challenge_token}"
290     chmod a+r "${WELLKNOWN}/${challenge_token}"
291
292     # Wait for hook script to deploy the challenge if used
293     if [[ -n "${HOOK}" ]]; then
294         ${HOOK} "deploy_challenge" "${altname}" "${challenge_token}" "${keyauth}"
295     fi
296
297     # Ask the acme-server to verify our challenge and wait until it becomes valid
298     echo " + Responding to challenge for ${altname}..."
299     result="$(signed_request "${challenge_uri}" '{"resource": "challenge", "keyAuthorization": "'"${keyauth}"'"}')"
300
301     status="$(printf '%s\n' "${result}" | get_json_string_value status)"
302
303     # get status until a result is reached => not pending anymore
304     while [[ "${status}" = "pending" ]]; do
305       sleep 1
306       status="$(http_request get "${challenge_uri}" | get_json_string_value status)"
307     done
308
309     rm -f "${WELLKNOWN}/${challenge_token}"
310
311     # Wait for hook script to clean the challenge if used
312     if [[ -n "${HOOK}" ]] && [[ -n "${challenge_token}" ]]; then
313       ${HOOK} "clean_challenge" "${altname}" "${challenge_token}" "${keyauth}"
314     fi
315
316     if [[ "${status}" = "valid" ]]; then
317       echo " + Challenge is valid!"
318     else
319       echo " + Challenge is invalid! (returned: ${status})" >&2
320       exit 1
321     fi
322
323   done
324
325   # Finally request certificate from the acme-server and store it in cert-${timestamp}.pem and link from cert.pem
326   echo " + Requesting certificate..."
327   csr64="$(openssl req -in "${BASEDIR}/certs/${domain}/cert-${timestamp}.csr" -outform DER | urlbase64)"
328   crt64="$(signed_request "${CA_NEW_CERT}" '{"resource": "new-cert", "csr": "'"${csr64}"'"}' | openssl base64 -e)"
329   crt_path="${BASEDIR}/certs/${domain}/cert-${timestamp}.pem"
330   printf -- '-----BEGIN CERTIFICATE-----\n%s\n-----END CERTIFICATE-----\n' "${crt64}" > "${crt_path}"
331   # try to load the certificate to detect corruption
332   echo " + Checking certificate..."
333   _openssl x509 -text < "${crt_path}"
334
335   # Create fullchain.pem
336   echo " + Creating fullchain.pem..."
337   cat "${crt_path}" > "${BASEDIR}/certs/${domain}/fullchain-${timestamp}.pem"
338   http_request get "$(openssl x509 -in "${BASEDIR}/certs/${domain}/cert-${timestamp}.pem" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem"
339   if ! grep "BEGIN CERTIFICATE" "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" > /dev/null 2>&1; then
340     openssl x509 -in "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" -inform DER -out "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" -outform PEM
341   fi
342   ln -sf "chain-${timestamp}.pem" "${BASEDIR}/certs/${domain}/chain.pem"
343   cat "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" >> "${BASEDIR}/certs/${domain}/fullchain-${timestamp}.pem"
344   ln -sf "fullchain-${timestamp}.pem" "${BASEDIR}/certs/${domain}/fullchain.pem"
345
346   # Update remaining symlinks
347   if [ ! "${privkey}" = "privkey.pem" ]; then
348     ln -sf "privkey-${timestamp}.pem" "${BASEDIR}/certs/${domain}/privkey.pem"
349   fi
350
351   ln -sf "cert-${timestamp}.csr" "${BASEDIR}/certs/${domain}/cert.csr"
352   ln -sf "cert-${timestamp}.pem" "${BASEDIR}/certs/${domain}/cert.pem"
353
354   # Wait for hook script to clean the challenge and to deploy cert if used
355   if [[ -n "${HOOK}" ]]; then
356       ${HOOK} "deploy_cert" "${domain}" "${BASEDIR}/certs/${domain}/privkey.pem" "${BASEDIR}/certs/${domain}/cert.pem" "${BASEDIR}/certs/${domain}/fullchain.pem"
357   fi
358
359   unset challenge_token
360   echo " + Done!"
361 }
362
363
364 # Usage: --cron (-c)
365 # Description: Sign/renew non-existant/changed/expiring certificates.
366 command_sign_domains() {
367   init_system
368
369   if [[ -n "${PARAM_DOMAIN:-}" ]]; then
370     DOMAINS_TXT="$(mktemp)"
371     printf -- "${PARAM_DOMAIN}" > "${DOMAINS_TXT}"
372   elif [[ -e "${BASEDIR}/domains.txt" ]]; then
373     DOMAINS_TXT="${BASEDIR}/domains.txt"
374   else
375     _exiterr "domains.txt not found and --domain not given"
376   fi
377
378   # Generate certificates for all domains found in domains.txt. Check if existing certificate are about to expire
379   <"${DOMAINS_TXT}" sed 's/^[[:space:]]*//g;s/[[:space:]]*$//g' | grep -vE '^(#|$)' | while read -r line; do
380     domain="$(printf '%s\n' "${line}" | cut -d' ' -f1)"
381     morenames="$(printf '%s\n' "${line}" | cut -s -d' ' -f2-)"
382     cert="${BASEDIR}/certs/${domain}/cert.pem"
383
384     force_renew="${PARAM_FORCE:-no}"
385
386     if [[ -z "${morenames}" ]];then
387       echo "Processing ${domain}"
388     else
389       echo "Processing ${domain} with alternative names: ${morenames}"
390     fi
391
392     if [[ -e "${cert}" ]]; then
393       printf " + Checking domain name(s) of existing cert..."
394
395       certnames="$(openssl x509 -in "${cert}" -text -noout | grep DNS: | sed 's/DNS://g' | tr -d ' ' | tr ',' '\n' | sort -u | tr '\n' ' ' | sed 's/ $//')"
396       givennames="$(echo "${domain}" "${morenames}"| tr ' ' '\n' | sort -u | tr '\n' ' ' | sed 's/ $//' | sed 's/^ //')"
397
398       if [[ "${certnames}" = "${givennames}" ]]; then
399         echo " unchanged."
400       else
401         echo " changed!"
402         echo " + Domain name(s) are not matching!"
403         echo " + Names in old certificate: ${certnames}"
404         echo " + Configured names: ${givennames}"
405         echo " + Forcing renew."
406         force_renew="yes"
407       fi
408     fi
409
410     if [[ -e "${cert}" ]]; then
411       echo " + Checking expire date of existing cert..."
412       valid="$(openssl x509 -enddate -noout -in "${cert}" | cut -d= -f2- )"
413
414       printf " + Valid till %s " "${valid}"
415       if openssl x509 -checkend $((RENEW_DAYS * 86400)) -noout -in "${cert}"; then
416         printf "(Longer than %d days). " "${RENEW_DAYS}"
417         if [[ "${force_renew}" = "yes" ]]; then
418           echo "Ignoring because renew was forced!"
419         else
420           echo "Skipping!"
421           continue
422         fi
423       else
424         echo "(Less than ${RENEW_DAYS} days). Renewing!"
425       fi
426     fi
427
428     # shellcheck disable=SC2086
429     sign_domain ${line}
430   done || true
431
432   # remove temporary domains.txt file if used
433   [[ -n "${PARAM_DOMAIN:-}" ]] && rm -f "${DOMAINS_TXT}"
434
435   exit 0
436 }
437
438 # Usage: --revoke (-r) path/to/cert.pem
439 # Description: Revoke specified certificate
440 command_revoke() {
441   init_system
442
443   cert="${1}"
444   if [[ -L "${cert}" ]]; then
445     # follow symlink and use real certificate name (so we move the real file and not the symlink at the end)
446     local link_target
447     link_target="$(readlink -n "${cert}")"
448     if [[ "${link_target}" =~ ^/ ]]; then
449       cert="${link_target}"
450     else
451       cert="$(dirname "${cert}")/${link_target}"
452     fi
453   fi
454   if [[ ! -f "${cert}" ]]; then
455     echo "ERROR: Could not find certificate ${cert}"
456     exit 1
457   fi
458   echo "Revoking ${cert}"
459   if [[ -z "${CA_REVOKE_CERT}" ]]; then
460     echo " + ERROR: Certificate authority doesn't allow certificate revocation." >&2
461     exit 1
462   fi
463   cert64="$(openssl x509 -in "${cert}" -inform PEM -outform DER | urlbase64)"
464   response="$(signed_request "${CA_REVOKE_CERT}" '{"resource": "revoke-cert", "certificate": "'"${cert64}"'"}')"
465   # if there is a problem with our revoke request http_request (via signed_request) will report this and "exit 1" out
466   # so if we are here, it is safe to assume the request was successful
467   echo " + SUCCESS"
468   echo " + renaming certificate to ${cert}-revoked"
469   mv -f "${cert}" "${cert}-revoked"
470 }
471
472 # Usage: --help (-h)
473 # Description: Show help text
474 command_help() {
475   printf "Usage: %s [-h] [command [argument]] [parameter [argument]] [parameter [argument]] ...\n\n" "${0}"
476   printf "Default command: help\n\n"
477   echo "Commands:"
478   grep -e '^[[:space:]]*# Usage:' -e '^[[:space:]]*# Description:' -e '^command_.*()[[:space:]]*{' "${0}" | while read -r usage; read -r description; read -r command; do
479     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]] || [[ ! "${command}" =~ ^command_ ]]; then
480       _exiterr "Error generating help text."
481     fi
482     printf " %-32s %s\n" "${usage##"# Usage: "}" "${description##"# Description: "}"
483   done
484   printf -- "\nParameters:\n"
485   grep -E -e '^[[:space:]]*# PARAM_Usage:' -e '^[[:space:]]*# PARAM_Description:' "${0}" | while read -r usage; read -r description; do
486     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]]; then
487       _exiterr "Error generating help text."
488     fi
489     printf " %-32s %s\n" "${usage##"# PARAM_Usage: "}" "${description##"# PARAM_Description: "}"
490   done
491 }
492
493 # Usage: --env (-e)
494 # Description: Output configuration variables for use in other scripts
495 command_env() {
496   echo "# letsencrypt.sh configuration"
497   load_config
498   typeset -p CA LICENSE HOOK RENEW_DAYS PRIVATE_KEY KEYSIZE WELLKNOWN PRIVATE_KEY_RENEW OPENSSL_CNF CONTACT_EMAIL LOCKFILE
499 }
500
501 main() {
502   COMMAND=""
503   set_command() {
504     [[ -z "${COMMAND}" ]] || _exiterr "Only one command can be executed at a time. See help (-h) for more information."
505     COMMAND="${1}"
506   }
507
508   check_parameters() {
509     if [[ -z "${1:-}" ]]; then
510       echo "The specified command requires additional parameters. See help:" >&2
511       echo >&2
512       command_help >&2
513       exit 1
514     elif [[ "${1:0:1}" = "-" ]]; then
515       _exiterr "Invalid argument: ${1}"
516     fi
517   }
518
519   while (( "${#}" )); do
520     case "${1}" in
521       --help|-h)
522         command_help
523         exit 0
524         ;;
525
526       --env|-e)
527         set_command env
528         ;;
529
530       --cron|-c)
531         set_command sign_domains
532         ;;
533
534       --revoke|-r)
535         shift 1
536         set_command revoke
537         check_parameters "${1:-}"
538         PARAM_REVOKECERT="${1}"
539         ;;
540
541       # PARAM_Usage: --domain (-d) domain.tld
542       # PARAM_Description: Use specified domain name(s) instead of domains.txt entry (one certificate!)
543       --domain|-d)
544         shift 1
545         check_parameters "${1:-}"
546         if [[ -z "${PARAM_DOMAIN:-}" ]]; then
547           PARAM_DOMAIN="${1}"
548         else
549           PARAM_DOMAIN="${PARAM_DOMAIN} ${1}"
550          fi
551         ;;
552
553
554       # PARAM_Usage: --force (-x)
555       # PARAM_Description: Force renew of certificate even if it is longer valid than value in RENEW_DAYS
556       --force|-x)
557         PARAM_FORCE="yes"
558         ;;
559
560       # PARAM_Usage: --privkey (-p) path/to/key.pem
561       # PARAM_Description: Use specified private key instead of account key (useful for revocation)
562       --privkey|-p)
563         shift 1
564         check_parameters "${1:-}"
565         PARAM_PRIVATE_KEY="${1}"
566         ;;
567
568       # PARAM_Usage: --config (-f) path/to/config.sh
569       # PARAM_Description: Use specified config file
570       --config|-f)
571         shift 1
572         check_parameters "${1:-}"
573         CONFIG="${1}"
574         ;;
575
576       *)
577         echo "Unknown parameter detected: ${1}" >&2
578         echo >&2
579         command_help >&2
580         exit 1
581         ;;
582     esac
583
584     shift 1
585   done
586
587   case "${COMMAND}" in
588     env) command_env;;
589     sign_domains) command_sign_domains;;
590     revoke) command_revoke "${PARAM_REVOKECERT}";;
591     *) command_help; exit1;;
592   esac
593 }
594
595 # Check for missing dependencies
596 check_dependencies
597
598 # Run script
599 main "${@:-}"